/************************************************************************\
* custom.cpp - A custom formatting library for foobar2000's              *
* foo_playlist_ouput library.                                            *
* Copyright (c) 2005 Brian A. Hartvigsen                                 *
* Some right reserved                                                    *
**************************************************************************
* This work is licensed under the Creative Commons                       *
* Attribution-NonCommercial License. To view a copy of this license,     *
* visit http://creativecommons.org/licenses/by-nc/2.0/ or send a letter  *
* to Creative Commons, 559 Nathan Abbott Way, Stanford, California       *
* 94305, USA.                                                            *
\************************************************************************/
#ifndef _FOOBAR2000_OUTPUT_FORMAT_H_
#define _FOOBAR2000_OUTPUT_FORMAT_H_

class NOVTABLE output_format : public service_base
{
public:
	virtual void get_name(string_base & out) = 0;
	virtual bool get_description(string_base & out) = 0;
	virtual void get_file_mask(string_base & out) = 0;

	virtual bool get_formating_string(string_base & out) = 0;
	virtual bool get_pre_output(string_base & out) = 0;
	virtual bool get_post_output(string_base & out) = 0;

	virtual void run(string8 & title, int titleLength, int needLength) = 0;

	static const GUID & get_class_guid()
	{
		// 67f3f73c-7033-4347-96f8-a4c6d6aafd22
		static const GUID guid = 
		{ 0x67f3f73c, 0x7033, 0x4347, { 0x96, 0xfb, 0xa4, 0xc6, 0xd6, 0xaa, 0xfd, 0x22 } };
		return guid;
	}
};

template<class T>
class output_format_factory : public service_factory_t<output_format,T> {};

#endif //__FOOBAR2000_OUTPUT_FORMAT_H_